Modules documentation
=====================

This file presents the various modules and their roles inside the game engine.

- Some modules revolves around a singleton that represent the whole system.
- Some modules are simple tasks (See tasks), like networking but reflect complex behavior and whole description is needed.
- Some modules are deeply integrated direct within different implementations in various places but a description was needed.
(Encryption support)

So, modules represent concept of different high-level features needed by a game engine.

List of modules 
---------------

### Allocators

See Doc/Modules/Allocators.txt

### Asset

Management system for all loaded assets in the engine at runtime.
See Doc/Modules/Asset.txt

### Encryption

See Doc/Modules/Encryption.txt

### File System

See Doc/Modules/FileSystem.txt

### Networking related

See Doc/Modules/Network.txt

### Rendering

See Doc/Modules/Rendering.txt

### SceneGraph

See Doc/Modules/Scenegraph.txt

### Scripting/LUA related

See Doc/Modules/Scripting.txt

### Sound System

See Doc/Modules/Audio.txt

### Tasks

See Doc/Modules/Tasks.txt

### Threading model

See Doc/Modules/Thread
